motorManagment = {};

function motorManagment.prerequisitesPresent(specializations)
   return true;
end;

function motorManagment:load(xmlFile)
	
	self.motorStopSoundVolumeCopy = self.motorStopSoundVolume;
	self.motorSoundVolumeCopy = self.motorSoundVolume;
	self.motorStartSoundVolumeCopy = self.motorStartSoundVolume;
	self.motorStopSoundVolume = 0;
	
	self.motorStopSoundCopy = self.motorStopSound;
	
	self.outSideSound = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.outSideSound#index"));
	setVisibility(self.outSideSound, false);
	
	self.exhaustParticleSystems2 = {};
    local exhaustParticleSystem2Count = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.exhaustParticleSystems#count"), 0);
    for i=1, exhaustParticleSystem2Count do
        local namei = string.format("vehicle.exhaustParticleSystems.exhaustParticleSystem%d", i);
        Utils.loadParticleSystem(xmlFile, self.exhaustParticleSystems2, namei, self.components, false, nil, self.baseDirectory)
    end;

	self.motorRun = false;
end;

function motorManagment:delete()
	Utils.deleteParticleSystem(self.exhaustParticleSystems2);
end;

function motorManagment:mouseEvent(posX, posY, isDown, isUp, button)
end;

function motorManagment:keyEvent(unicode, sym, modifier, isDown)
end;

function motorManagment:update(dt)
	if self:getIsActiveForInput() then
		if not self.motorRun then
			if InputBinding.hasEvent(InputBinding.CATIGNITION) then
				self.motorSoundVolume = self.motorSoundVolumeCopy;
				self:startMotor();
				self.motorRun = true;
			end;
			acceleration = -InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
			if InputBinding.isAxisZero(acceleration) then
				acceleration = -InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
			end;
			if math.abs(acceleration) > 0.3 then
				self.motorSoundVolume = self.motorSoundVolumeCopy;
				self:startMotor();
				self.motorRun = true;
			end;
		else
			if InputBinding.hasEvent(InputBinding.CATIGNITION) then
				self.motorStopSound = self.motorStopSoundCopy;
				self.motorStopSoundVolume = self.motorStopSoundVolumeCopy;
				self.motorSoundVolume = 0;
				self:stopMotor();
				self:onDeactivateAttachements();
				self.motorStopSound = nil;
				self.motorRun = false;
			end;
		end;
	end;
	if self.isMotorStarted then
		if self.playMotorSound then
			Utils.setEmittingState(self.exhaustParticleSystems, false);
		else
			Utils.setEmittingState(self.exhaustParticleSystems, true);
		end;
		if self.motorSoundRun ~= nil then
			local input = InputBinding.getAnalogInputAxis(InputBinding.AXIS_FORWARD);
            if InputBinding.isAxisZero(input) then
                input = InputBinding.getDigitalInputAxis(InputBinding.AXIS_FORWARD);
            end;
			local alpha = 0.9;
            local roundPerMinute = self.lastRoundPerMinute*alpha + (1-alpha)*(self.motor.lastMotorRpm-self.motor.minRpm);
			self.lastRoundPerMinute = roundPerMinute;
			if self.motor.speedLevel ~= 0 then
				local maxRpm  = self.motor.maxRpm[self.motor.speedLevel];
				local rpmVolume = Utils.clamp(math.abs(roundPerMinute)/((maxRpm - self.motor.minRpm)), 0.0, 1.0);
				setSampleVolume(self.motorSoundRun, rpmVolume);
			elseif input ~= 0 then
				local maxRpm  = self.motor.maxRpm[3];
				local rpmVolume = Utils.clamp(math.abs(roundPerMinute)/((maxRpm - self.motor.minRpm)), 0.0, 1.0);
				setSampleVolume(self.motorSoundRun, rpmVolume);
			end;
		end;
	else
		Utils.setEmittingState(self.exhaustParticleSystems, false);
	end;
	if self.isEntered then
		if self.cameras[2].isActivated then
			self.motorStartSoundVolume = 0.5;
			self.motorStopSoundVolume = 0.5;
			setSampleVolume(self.motorSound, self.motorSoundVolume/2);
			setSampleVolume(self.motorSoundRun, self.motorSoundRunVolume/3);
		else
			setSampleVolume(self.motorSound, self.motorSoundVolumeCopy);
		end;
	end;
	if self.motorRun and not self.isMotorStarted then
		local fuelUsed = 0.00018;
		self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);
		g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
		g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
	end;
end;

function motorManagment:onLeave()
	if self.motorRun then
		setVisibility(self.outSideSound, true);
		Utils.setEmittingState(self.exhaustParticleSystems2, true);
	end;
end;

function motorManagment:onEnter()	
	self.motorSoundVolume = 0;
	self.motorStopSoundVolume = 0;
	self:stopMotor();
	if self.motorRun then
		self.motorSoundVolume = self.motorSoundVolumeCopy;
		setVisibility(self.outSideSound, false);
		Utils.setEmittingState(self.exhaustParticleSystems2, false);
		self.isMotorStarted = true;
		self.playMotorSound = true;
		self.playMotorSoundTime = self.time;
	end;
end;

function motorManagment:draw()
end;

	